# function to add the observe() functions for any \\shinyGotoTab commands

addTabObservers = function(globalInfoEnv) {
  gotoTabs = getGlobal("gotoTabs", globalInfoEnv)
  if (is.null(gotoTabs)) return(character(0))
  tabJumpCode = character(0)
  for (i in 1:nrow(gotoTabs)) {
    asName = make.names(gotoTabs[i, "tab"])
    for (j in 1:gotoTabs[i, "count"]) {
      this = paste0(asName, j)
      tabJumpCode = c(tabJumpCode,
                      paste0('  observe({if (input$gotoTab', this, ' > 0) {'),
                      paste0('    session$sendCustomMessage("tabJumpCallback", "', gotoTabs[i, "tab"], '")'),
                             '  }})')
    }
  } 
  return(tabJumpCode)
}